︠cc9b5d5f-6edc-43d1-84d9-51f88ade20a2is︠
#Bard - Sage - Riemann Sums 3D Graph Demo

html("<h2 style='color:blue'>Bard - Sage - Riemann Sums 3D Graph Demo</h2>")

html("<p>One of the following situations will occur when you start this worksheet:</p><ul><li><b>The graph or formulas are visible below the input boxes, sliders and check boxes</b>: proceed to use the worksheet.</li><li><b>The code is visible</b>: put the cursor in the code, and then click on Run (the green square with the triangle in the menu above), which will bring up the graph or formulas.</li><li><b>The code is not visible, and you see “(Evaluate this cell to use this interact)” instead of the graph or formulas</b>: double-click where that message is written to bring up the code, put the cursor in the code, and then click on Run (the green square with the triangle in the menu above), which will bring up the graph or formulas.</li>")

html("<p>Using the worksheet:</p><ul><li>Once the graph or formulas are visible, manipulate the entries via the input boxes, sliders and check boxes.</li><li>When you change something in an input box, hit Return on your keyboard.</li><li>You can add a mesh to the graph by clicking on Mesh, and you can make the graph have no opacity by clicking on Opacity 1.</li></ul>")

y, z = var('y, z');
@interact
def _(
    f = input_box(default = x^2 + y^2, label = "$f(x, y)$"),
    abinterval=range_slider(-10, 10, 1, default=(0, 2), label="$[a, b]$"),
    cdinterval=range_slider(-10, 10, 1, default=(0, 3), label="$[c, d]$"),
    xinterval=range_slider(-20, 20, 1, default = (-6, 6), label = "$x$-interval"),
    yinterval=range_slider(-20, 20, 1, default = (-6, 6), label = "$y$-interval"),
    zinterval=range_slider(-100, 100, 1, default = (-2, 15), label = "$z$-interval"),
    n = slider(2, 100, 2, default=4, label="subintervals of $[a, b]$"),
    m = slider(2, 100, 2, default=4, label="subintervals of $[c, d]$"),
    en = selector(['Lower Left', 'Upper Left', 'Midpoint', 'Upper Right', 'Lower Right'], nrows=1, label="Sum"),
    messh = ("Mesh", False),
    oppa = ("Opacity 1", False),
    ):

        fgz = 25;

        a, b = map(QQ, abinterval);
        c, d = map(QQ, cdinterval);
        x_min, x_max = map(QQ, xinterval);
        y_min, y_max = map(QQ, yinterval);
        zzmin, zzmax = map(QQ, zinterval);

        dx = (b - a)/n;
        dy = (d - c)/m;

        ls = [zzmin, zzmax];

        z_max = max(ls);
        z_min = min(ls);

        fz = f - z;

        opac = 0.5;
        if oppa == True:
            opac = 1;
        else:
            opac = 0.5;

        if messh == True:
            plt = implicit_plot3d(fz == 0, (x, x_min, x_max), (y, y_min, y_max), (z, z_min, z_max), mesh = True, opacity = opac, figsize = fgz, aspect_ratio = [1, 1, 1]);
        else:
            plt = implicit_plot3d(fz == 0, (x, x_min, x_max), (y, y_min, y_max), (z, z_min, z_max), opacity = opac, figsize = fgz, aspect_ratio = [1, 1, 1]);

        huu = [[f(x = a + i*dx, y = c + j*dy) for i in [1..n]] for j in [1..m]];
        hlu = [[f(x = a + (i - 1)*dx, y = c + j*dy) for i in [1..n]] for j in [1..m]];
        hul = [[f(x = a + i*dx, y = c + (j - 1)*dy) for i in [1..n]] for j in [1..m]];
        hll = [[f(x = a + (i - 1)*dx, y = c + (j - 1)*dy) for i in [1..n]] for j in [1..m]];
        hm = [[f(x = a + (i - 1/2)*dx, y = c + (j - 1/2)*dy) for i in [1..n]] for j in [1..m]];

        if en == 'Upper Left':
            hh = hlu;
        elif en == 'Lower Left':
            hh = hll;
        elif en == 'Midpoint':
            hh = hm;
        elif en == 'Lower Right':
            hh = hul;
        elif en == 'Upper Right':
            hh = huu;

        uub = [[(a + i*dx, c + j*dy, 0) for i in [1..n]] for j in [1..m]];
        lub = [[(a + (i - 1)*dx, c + j*dy, 0) for i in [1..n]] for j in [1..m]];
        ulb = [[(a + i*dx, c + (j - 1)*dy, 0) for i in [1..n]] for j in [1..m]];
        llb = [[(a + (i - 1)*dx, c + (j - 1)*dy, 0) for i in [1..n]] for j in [1..m]];

        uut = [[(a + i*dx, c + j*dy, hh[j - 1][i - 1]) for i in [1..n]] for j in [1..m]];
        lut = [[(a + (i - 1)*dx, c + j*dy, hh[j - 1][i - 1]) for i in [1..n]] for j in [1..m]];
        ult = [[(a + i*dx, c + (j - 1)*dy, hh[j - 1][i - 1]) for i in [1..n]] for j in [1..m]];
        llt = [[(a + (i - 1)*dx, c + (j - 1)*dy, hh[j - 1][i - 1]) for i in [1..n]] for j in [1..m]];

        zuu = [line([uub[j - 1][i - 1], uut[j - 1][i - 1]], color = 'red', thickness=1, figsize = fgz) for i in [1..n] for j in [1..m]];
        zlu = [line([lub[j - 1][i - 1], lut[j - 1][i - 1]], color = 'red', thickness=1, figsize = fgz) for i in [1..n] for j in [1..m]];
        zul = [line([ulb[j - 1][i - 1], ult[j - 1][i - 1]], color = 'red', thickness=1, figsize = fgz) for i in [1..n] for j in [1..m]];
        zll = [line([llb[j - 1][i - 1], llt[j - 1][i - 1]], color = 'red', thickness=1, figsize = fgz) for i in [1..n] for j in [1..m]];

        wt = [polygon([lub[j - 1][i - 1], lut[j - 1][i - 1], uut[j - 1][i - 1], uub[j - 1][i - 1]], alpha = 0.3, color = 'purple', figsize = fgz) for i in [1..n] for j in [1..m]];
        wb = [polygon([llb[j - 1][i - 1], llt[j - 1][i - 1], ult[j - 1][i - 1], ulb[j - 1][i - 1]], alpha = 0.3, color = 'purple', figsize = fgz) for i in [1..n] for j in [1..m]];
        wr = [polygon([ulb[j - 1][i - 1], ult[j - 1][i - 1], uut[j - 1][i - 1], uub[j - 1][i - 1]], alpha = 0.3, color = 'purple', figsize = fgz) for i in [1..n] for j in [1..m]];
        wl = [polygon([llb[j - 1][i - 1], llt[j - 1][i - 1], lut[j - 1][i - 1], lub[j - 1][i - 1]], alpha = 0.3, color = 'purple', figsize = fgz) for i in [1..n] for j in [1..m]];

        u = [polygon([ult[j - 1][i - 1], uut[j - 1][i - 1], lut[j - 1][i - 1], llt[j - 1][i - 1]], alpha = 0.3, color = 'green', figsize = fgz) for i in [1..n] for j in [1..m]];

        zzuu = sum(zuu);
        zzlu = sum(zlu);
        zzul = sum(zul);
        zzll = sum(zll);

        wwt = sum(wt);
        wwb = sum(wb);
        wwr = sum(wr);
        wwl = sum(wl);

        uu = sum(u)

        gul = sum([f(x = a + (i-1)*dx, y = c + k*dy)*dx*dy for i in [1..n] for k in [1..m]]).n()
        gll = sum([f(x = a + (i-1)*dx, y = c + (k-1)*dy)*dx*dy for i in [1..n] for k in [1..m]]).n()

        gm = sum([f(x = a + (i-1/2)*dx, y = c + (k-1/2)*dy)*dx*dy for i in [1..n] for k in [1..m]]).n()

        glr = sum([f(x = a + i*dx, y = c + (k-1)*dy)*dx*dy for i in [1..n] for k in [1..m]]).n()
        gur = sum([f(x = a + i*dx, y = c + k*dy)*dx*dy for i in [1..n] for k in [1..m]]).n()

        html(r'''
        <div class="math">
        \begin{align*}
        f(x, y) &= %s \\\
        a = %s \qquad b &= %s \qquad n = %s\\\
        c = %s \qquad d &= %s \qquad m = %s\\\
        \text{Upper Left Sum} = %s \qquad &{} \qquad \text{Upper Right Sum} = %s\\\
        \text{Midpoint Sum} &= %s \\\
        \text{Lower Left Sum} = %s \qquad &{} \qquad \text{Lower Right Sum} = %s
        \end{align*}
        </div>
        ''' % (latex(f), a, b, n, c, d, m, gul, gur, gm, gll, glr))
        show(plt + zzuu + zzlu + zzul + zzll + wwt + wwb + wwr + wwl + uu)
︡b060bd96-cb5f-42e6-ac25-1ad9bf6b8317︡︡{"hide":"input"}︡{"html":"<h2 style='color:blue'>Bard - Sage - Riemann Sums 3D Graph Demo</h2>","done":false}︡{"hide":"input"}︡{"html":"<p>One of the following situations will occur when you start this worksheet:</p><ul><li><b>The graph or formulas are visible below the input boxes, sliders and check boxes</b>: proceed to use the worksheet.</li><li><b>The code is visible</b>: put the cursor in the code, and then click on Run (the green square with the triangle in the menu above), which will bring up the graph or formulas.</li><li><b>The code is not visible, and you see “(Evaluate this cell to use this interact)” instead of the graph or formulas</b>: double-click where that message is written to bring up the code, put the cursor in the code, and then click on Run (the green square with the triangle in the menu above), which will bring up the graph or formulas.</li>","done":false}︡{"hide":"input"}︡{"html":"<p>Using the worksheet:</p><ul><li>Once the graph or formulas are visible, manipulate the entries via the input boxes, sliders and check boxes.</li><li>When you change something in an input box, hit Return on your keyboard.</li><li>You can add a mesh to the graph by clicking on Mesh, and you can make the graph have no opacity by clicking on Opacity 1.</li></ul>","done":false}︡{"interact":{"style":"None","flicker":false,"layout":[[["f",12,null]],[["abinterval",12,null]],[["cdinterval",12,null]],[["xinterval",12,null]],[["yinterval",12,null]],[["zinterval",12,null]],[["n",12,null]],[["m",12,null]],[["en",12,null]],[["messh",12,null]],[["oppa",12,null]],[["",12,null]]],"id":"3078bfb9-abdd-4937-ae1e-d66543a58120","controls":[{"control_type":"input-box","default":"x^2 + y^2","label":"$f(x, y)$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"range-slider","default":[10,12],"var":"abinterval","width":null,"vals":["-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10"],"animate":true,"label":"$[a, b]$","display_value":true},{"control_type":"range-slider","default":[10,13],"var":"cdinterval","width":null,"vals":["-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10"],"animate":true,"label":"$[c, d]$","display_value":true},{"control_type":"range-slider","default":[14,26],"var":"xinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$x$-interval","display_value":true},{"control_type":"range-slider","default":[14,26],"var":"yinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$y$-interval","display_value":true},{"control_type":"range-slider","default":[98,115],"var":"zinterval","width":null,"vals":["-100","-99","-98","-97","-96","-95","-94","-93","-92","-91","-90","-89","-88","-87","-86","-85","-84","-83","-82","-81","-80","-79","-78","-77","-76","-75","-74","-73","-72","-71","-70","-69","-68","-67","-66","-65","-64","-63","-62","-61","-60","-59","-58","-57","-56","-55","-54","-53","-52","-51","-50","-49","-48","-47","-46","-45","-44","-43","-42","-41","-40","-39","-38","-37","-36","-35","-34","-33","-32","-31","-30","-29","-28","-27","-26","-25","-24","-23","-22","-21","-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100"],"animate":true,"label":"$z$-interval","display_value":true},{"control_type":"slider","default":1,"var":"n","width":null,"vals":["2","4","6","8","10","12","14","16","18","20","22","24","26","28","30","32","34","36","38","40","42","44","46","48","50","52","54","56","58","60","62","64","66","68","70","72","74","76","78","80","82","84","86","88","90","92","94","96","98","100"],"animate":true,"label":"subintervals of $[a, b]$","display_value":true},{"control_type":"slider","default":1,"var":"m","width":null,"vals":["2","4","6","8","10","12","14","16","18","20","22","24","26","28","30","32","34","36","38","40","42","44","46","48","50","52","54","56","58","60","62","64","66","68","70","72","74","76","78","80","82","84","86","88","90","92","94","96","98","100"],"animate":true,"label":"subintervals of $[c, d]$","display_value":true},{"buttons":false,"control_type":"selector","ncols":null,"button_classes":null,"default":0,"lbls":["Lower Left","Upper Left","Midpoint","Upper Right","Lower Right"],"label":"Sum","nrows":1,"width":null,"var":"en"},{"default":false,"var":"messh","readonly":false,"control_type":"checkbox","label":"Mesh"},{"default":false,"var":"oppa","readonly":false,"control_type":"checkbox","label":"Opacity 1"}]},"done":false}︡{"done":true}
︠e6277924-1c65-4bb8-9051-3089044d061e︠









